Imports System.Math

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents txtNumPoints As System.Windows.Forms.TextBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents btnGo As System.Windows.Forms.Button
    Friend WithEvents picCanvas As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtNumPoints = New System.Windows.Forms.TextBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.btnGo = New System.Windows.Forms.Button
        Me.picCanvas = New System.Windows.Forms.PictureBox
        Me.SuspendLayout()
        '
        'txtNumPoints
        '
        Me.txtNumPoints.Location = New System.Drawing.Point(48, 0)
        Me.txtNumPoints.Name = "txtNumPoints"
        Me.txtNumPoints.Size = New System.Drawing.Size(32, 20)
        Me.txtNumPoints.TabIndex = 0
        Me.txtNumPoints.Text = "7"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(0, 0)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(48, 16)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "# Points"
        '
        'btnGo
        '
        Me.btnGo.Location = New System.Drawing.Point(88, 0)
        Me.btnGo.Name = "btnGo"
        Me.btnGo.Size = New System.Drawing.Size(48, 23)
        Me.btnGo.TabIndex = 2
        Me.btnGo.Text = "Go"
        '
        'picCanvas
        '
        Me.picCanvas.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.picCanvas.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.picCanvas.Location = New System.Drawing.Point(0, 32)
        Me.picCanvas.Name = "picCanvas"
        Me.picCanvas.Size = New System.Drawing.Size(735, 485)
        Me.picCanvas.TabIndex = 3
        Me.picCanvas.TabStop = False
        '
        'Form1
        '
        Me.AcceptButton = Me.btnGo
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(736, 517)
        Me.Controls.Add(Me.picCanvas)
        Me.Controls.Add(Me.btnGo)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.txtNumPoints)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private m_NumPoints As Integer = 0

    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        Try
            Dim num_points As Integer = Integer.Parse(txtNumPoints.Text)
            If num_points < 3 Then
                MessageBox.Show("# Points must be at least 3", "Invalid Number", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Else
                m_NumPoints = num_points
                picCanvas.Invalidate()
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Invalid Number", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    ' Draw the applicable stars.
    Private Sub picCanvas_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picCanvas.Paint
        If m_NumPoints < 3 Then Exit Sub

        Const RADIUS As Integer = 40
        Dim x, y As Integer

        ' Position the original points.
        Dim pts(m_NumPoints - 1) As PointF
        Dim theta As Double = -PI / 2
        Dim dtheta As Double = 2 * PI / m_NumPoints
        For i As Integer = 0 To m_NumPoints - 1
            pts(i).X = RADIUS * Cos(theta)
            pts(i).Y = RADIUS * Sin(theta)
            theta += dtheta
        Next i

        ' Draw stars.
        y = RADIUS + 5
        x = RADIUS + 5
        Dim sf As New StringFormat
        sf.Alignment = StringAlignment.Center
        sf.LineAlignment = StringAlignment.Near
        e.Graphics.Clear(picCanvas.BackColor)
        For skip As Integer = 1 To m_NumPoints \ 2
            ' See if they are relatively prime.
            If GCD(skip, m_NumPoints) = 1 Then
                ' Draw the star.
                DrawStar(e.Graphics, x, y, pts, skip)

                ' Draw a label.
                e.Graphics.DrawString(skip.ToString, picCanvas.Font, Brushes.Black, x, y + RADIUS + 2, sf)

                x += 2 * RADIUS + 5
                If x + RADIUS >= picCanvas.Width Then
                    y += 2 * RADIUS + 15
                    x = RADIUS + 5
                End If
            End If
        Next skip
    End Sub

    ' Return the greatest common divisor (GCD) of a and b.
    Public Function GCD(ByVal a As Long, ByVal b As Long) As Long
        Dim tmp As Long
        Dim remainder As Long

        ' Make a >= b.
        a = Abs(a)
        b = Abs(b)
        If a < b Then
            tmp = a
            a = b
            b = tmp
        End If

        ' Pull out remainders.
        Do
            remainder = a Mod b
            If remainder = 0 Then Exit Do
            a = b
            b = remainder
        Loop

        Return b
    End Function

    ' Draw a star centered at (x, y) using this skip value.
    Private Sub DrawStar(ByVal gr As Graphics, ByVal x As Integer, ByVal y As Integer, ByVal orig_pts() As PointF, ByVal skip As Integer)
        ' Make a PointF array with the points in the proper order.
        Dim pts(m_NumPoints - 1) As PointF
        For i As Integer = 0 To m_NumPoints - 1
            pts(i) = orig_pts((i * skip) Mod m_NumPoints)
        Next i

        ' Draw the star.
        gr.TranslateTransform(x, y)
        gr.DrawPolygon(Pens.Blue, pts)
        gr.ResetTransform()
    End Sub
End Class
